#include<bonnet.h>

struct buffer_head *bh;

char *new_balloc(int count)
{
    return malloc(count * BLKSIZE);
}

void init_buffer_cache()
{
	struct buffer_head *tmp=NULL;
	struct buffer_head *prev=NULL;
	int i;

	for(i=0;i<MAX_BUFFER;i++)
	{
		tmp = (buffer_head *)malloc(sizeof(struct buffer_head));
		tmp->status = STATUS_FREE;
		tmp->count  = 0;
		tmp->block_num = 0;
		tmp->device = 0; // ignore
		tmp->buffer = NULL;

		tmp->next_free = NULL;
		tmp->prev_free = NULL;

		tmp->next_lru = NULL;
		tmp->prev_lru = NULL;

		tmp->next_hash = NULL;
		tmp->prev_hash = NULL;

		if(i == 0)
		{
			bh = tmp;
		}

		// setting PREV,NEXT
		if(prev != NULL) 
		{
			prev->next_free = tmp;
			tmp->prev_free = prev;
		}

		prev = tmp;
	}
}
