#include<bonnet.h>


struct ext2_inode* iget(inode_t inode)
{
    struct ext2_inode *ret;
    struct ext2_group_desc *gd;
    int block;

    char *buf;

    if(inode < 1)
    {
        printf("err");
        return NULL;
    }
    inode--;

    ret = (struct ext2_inode *)malloc(sizeof(struct ext2_inode));
    buf = malloc(BLKSIZE);

    gd = fs_info->gd;
    gd+=INODE2GROUP(inode);

    block = (INODE2TABLE(inode) / (BLKSIZE / sizeof(struct ext2_inode))) + gd->bg_inode_table;

    getblk(block,buf,1);
    buf+= (INODE2TABLE(inode) % (BLKSIZE / sizeof(struct ext2_inode))) * sizeof(struct ext2_inode);
    memcpy(ret,buf,sizeof(struct ext2_inode));
    return ret;
}
