#include<bonnet.h>


struct ext2_inode* iget(inode_t inode)
{
    struct ext2_inode *ret;
    struct ext2_group_desc *gd;
    int block;

    char *buf;

    if(inode < 1)
    {
        printf("err");
        return NULL;
    }
    inode--;

    ret = (struct ext2_inode *)malloc(sizeof(struct ext2_inode));
    buf = malloc(BLKSIZE);

    gd = fs_info->gd;
    gd+=INODE2GROUP(inode);

    block = (INODE2TABLE(inode) / (BLKSIZE / sizeof(struct ext2_inode))) + gd->bg_inode_table;

    bread(block,buf,1);
    buf+= (INODE2TABLE(inode) % (BLKSIZE / sizeof(struct ext2_inode))) * sizeof(struct ext2_inode);
    memcpy(ret,buf,sizeof(struct ext2_inode));
    return ret;
}

#define NR (BLKSIZE/4)
int bmap(inode_t file,int offset)
{
	int tmp;
	int tmp2;
	int level;
	int ret;
	struct ext2_inode *inode = iget(file);
	block_t block = new_balloc(1);

	tmp = offset / BLKSIZE;

	if(tmp < 12)
		level = 0;
	else if(tmp < NR+12)
		level = 1;
	else if(tmp < NR*NR+12)
		level = 2;
	else if(tmp < NR*NR*NR+12)
		level = 3;

	printf("level : %d\n",level);
	if(level == 0)
		return (inode->i_block[tmp]);
	else 
	{
		tmp -= 12;

		if(level == 1)
		{
			bread(inode->i_block[12],block,1);
			tmp %= NR;
			block+=tmp*4;
			memcpy(&ret,block,4);
			return ret;
		}
		else if(level == 2)
		{
			bread(inode->i_block[13],block,1);
			tmp2 = tmp / NR;
			block+=tmp2*4;
			memcpy(&ret,block,4);
			bread(ret,block,1);

			tmp2 = tmp % NR;
			block+=tmp2*4;
			memcpy(&ret,block,4);
			bread(ret,block,1);
			printf("2ret : %d",ret);
			return ret;
		}
		else if(level == 3)
		{
		}

	}
}
