#include<bonnet.h>

#define PRSB(no,name) printf("%d : %d\n",no,sb->name);
#define PRGD(no,name) printf("%d : %d\n",no,gd->name);

void print_group_descriptor(struct ext2_group_desc *gd)
{
	PRGD(1,bg_block_bitmap);
	PRGD(2,bg_inode_bitmap);
	PRGD(3,bg_free_blocks_count);
	PRGD(4,bg_used_dirs_count);
}

void print_super_block(struct ext2_super_block *sb)
{
	PRSB(0,s_block_group_nr);
	PRSB(1,s_inodes_count);
	PRSB(2,s_blocks_count);
	PRSB(3,s_r_blocks_count);
	PRSB(4,s_free_blocks_count);
	PRSB(5,s_free_inodes_count);
	PRSB(6,s_first_data_block);
	PRSB(7,s_log_block_size);
	PRSB(8,s_log_frag_size);
	PRSB(9,s_blocks_per_group);
	PRSB(10,s_frags_per_group);
	PRSB(11,s_inodes_per_group);
	PRSB(12,s_mtime);
	PRSB(13,s_wtime);
	PRSB(14,s_mnt_count);
	printf("(%c",sb->s_volume_name[0]);
	printf("%c",sb->s_volume_name[1]);
	printf("%c",sb->s_volume_name[2]);
	printf("%c",sb->s_volume_name[3]);
}
