#include<bonnet.h>

DIR *opendir(char *pathname)
{
	inode_t inode;
	struct ext2_inode *ino;
	DIR *dp;

	if(pathname == NULL)
		return NULL;

	/* pathname  丮 ƴ϶   */

	dp = (DIR *)malloc(sizeof(DIR));

	inode = namei(pathname);
	ino = iget(inode);
	if(!ISDIR(ino->i_mode))
		return NULL;

	dp->inode = inode;
	dp->index = 0;
	dp->blk = new_balloc(1);

	bread(ino->i_block[0],dp->blk,1);

	return dp;
}

struct dirent *readdir(DIR *dp)
{
	struct ext2_dir_entry *dir_entry;
	char *ptr;
	struct dirent *ret;

	if(dp == NULL)
		return NULL;

	ptr = dp->blk;
	ptr+= dp->index;

	dir_entry = (struct ext2_dir_entry *)malloc(sizeof(struct ext2_dir_entry));

	memcpy(dir_entry,ptr,sizeof(struct ext2_dir_entry));

    dir_entry->name[dir_entry->name_len]='\0';
    dp->index += dir_entry->rec_len;

	ret = (struct dirent *)malloc(sizeof(struct dirent));
	memcpy(ret,dir_entry,sizeof(struct dirent));

	ret->d_ino = dir_entry->inode;
	strcpy(ret->d_name,dir_entry->name);

	return ret;
}
