/*
 * Linux dependent Header
 *
 */

#include<unistd.h>
#include<stdio.h>
#include<stdlib.h>
#include<sys/io.h>
#include<string.h>


/*
 * Macro
 *
 */

#define sdelay() \
{\
	asm("nop;nop;nop;");\
}\

/*
 *
 * Bonnet
 *
 */

#include<ide.h>
#include<types.h>
#include<stat.h>
#include<dirent.h>
#include<ext2.h>
#include<vfs.h>

/* namei.c */
inode_t find_inode_by_name(inode_t base,char *dir);
inode_t namei(char *path);

/* inode.c */
struct ext2_inode* iget(inode_t inode);

/* ide.c */
int ide_read(int lba,char *buf,int count);
int ide_write(int lba,char *buf,int count);

/* debug.c */
void print_group_descriptor(struct ext2_group_desc *gd);
void print_super_block(struct ext2_super_block *sb);

/* mount.c */
int mount(int drvno,int partno);
void ext2_init();

/* buffer.c */
char *new_balloc(int count);

/* read_write.c */
int bread(int block,char *buf,int count);
int sread(int sector,char *buf,int count);

/* bitmap.c */
int check_block_bitmap(int blkno);
int check_inode_bitmap(int inodno);

/* dir.c */
DIR *opendir(char *pathname);
struct dirent *readdir(DIR *dp);

/* stat.c */
int stat(char *pathname,struct stat *buf);
