#define IFMT  00170000
#define IFSOCK 0140000
#define IFLNK  0120000
#define IFREG  0100000
#define IFBLK  0060000
#define IFDIR  0040000
#define IFCHR  0020000
#define IFIFO  0010000
#define ISUID  0004000
#define ISGID  0002000
#define ISVTX  0001000

#define ISLNK(m)  (((m) & IFMT) == IFLNK)
#define ISREG(m)  (((m) & IFMT) == IFREG)
#define ISDIR(m)  (((m) & IFMT) == IFDIR)
#define ISCHR(m)  (((m) & IFMT) == IFCHR)
#define ISBLK(m)  (((m) & IFMT) == IFBLK)
#define ISFIFO(m) (((m) & IFMT) == IFIFO)
#define ISSOCK(m) (((m) & IFMT) == IFSOCK)

#define IRWXU 00700
#define IRUSR 00400
#define IWUSR 00200
#define IXUSR 00100

#define IRWXG 00070
#define IRGRP 00040
#define IWGRP 00020
#define IXGRP 00010

#define IRWXO 00007
#define IROTH 00004
#define IWOTH 00002
#define IXOTH 00001
