struct file_system_info
{
	struct ext2_super_block sb;
	struct ext2_group_desc *gd;

	int max_gd_count;
	int blksize;

	//physical layer
	int sec_count;
	int sec_start;	


};

struct file_system_info *fs_info;

#define BLKSIZE fs_info->blksize
#define SECSIZE 512

#define INODE2GROUP(inode) (inode / (fs_info->sb.s_inodes_per_group))
#define INODE2TABLE(inode) (inode % (fs_info->sb.s_inodes_per_group))

#define BLOCK2GROUP(block) (block / (fs_info->sb.s_blocks_per_group))
#define BLOCK2TABLE(block) (block % (fs_info->sb.s_blocks_per_group))

